var canvas;
var cntx;
var fVal;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
    
    window.addEventListener("beforeunload",function(e){
        clearInterval(timerLoop);
    });
} 

function initialiseGUI(){
	chkRed=new chkbox(cntx,chkRedLEFT,chkRedTOP,"Αποχρώσεις του κόκκινου",true);
    chkGreen=new chkbox(cntx,chkGreenLEFT,chkGreenTOP,"Αποχρώσεις του πράσινου",false);
    chkBlue=new chkbox(cntx,chkBlueLEFT,chkBlueTOP,"Αποχρώσεις του μπλε",false);
    
    chkDrawMany=new chkbox(cntx,chkDrawManyLEFT,chkDrawManyTOP,"Ίχνος",false);
    chkXORGraphics=new chkbox(cntx,chkXORGraphicsLEFT,chkXORGraphicsTOP,"Ανάμιξη χρώματος",false);
    chkFullColor=new chkbox(cntx,chkFullColorLEFT,chkFullColorTOP,"Χρωματικό μοτίβο",false);
    chkCompactDraw=new chkbox(cntx,chkCompactDrawLEFT,chkCompactDrawTOP,"Συμπαγές σχήμα",false);
    
    HscrTilesPerRow=new slider(HscrTilesPerRowLEFT,HscrTilesPerRowTOP,HscrTilesPerRowWIDTH,HscrTilesPerRowHEIGHT,HscrTilesPerRowMin,HscrTilesPerRowMax,HscrTilesPerRowMin,HscrTilesPerRowVisible,HscrTilesPerRowScaleDigital,[],HscrTilesPerRowViewComparative,cntx,false,valuePosFixed);
    HscrTilesPerColumn=new slider(HscrTilesPerColumnLEFT,HscrTilesPerColumnTOP,HscrTilesPerColumnWIDTH,HscrTilesPerColumnHEIGHT,HscrTilesPerColumnMin,HscrTilesPerColumnMax,HscrTilesPerColumnMin,HscrTilesPerColumnVisible,HscrTilesPerColumnScaleDigital,[],HscrTilesPerColumnViewComparative,cntx,false,valuePosFixed);
    HscrRedFactor=new slider(HscrRedFactorLEFT,HscrRedFactorTOP,HscrRedFactorWIDTH,HscrRedFactorHEIGHT,HscrRedFactorMin,HscrRedFactorMax,HscrRedFactorMin,HscrRedFactorVisible,HscrRedFactorScaleDigital,[],HscrRedFactorViewComparative,cntx,false,valuePosFixed);
    HscrGreenFactor=new slider(HscrGreenFactorLEFT,HscrGreenFactorTOP,HscrGreenFactorWIDTH,HscrGreenFactorHEIGHT,HscrGreenFactorMin,HscrGreenFactorMax,HscrGreenFactorMin,HscrGreenFactorVisible,HscrGreenFactorScaleDigital,[],HscrGreenFactorViewComparative,cntx,false,valuePosFixed);
    HscrBlueFactor=new slider(HscrBlueFactorLEFT,HscrBlueFactorTOP,HscrBlueFactorWIDTH,HscrBlueFactorHEIGHT,HscrBlueFactorMin,HscrBlueFactorMax,HscrBlueFactorMin,HscrBlueFactorVisible,HscrBlueFactorScaleDigital,[],HscrBlueFactorViewComparative,cntx,false,valuePosFixed);
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    
    TilesPerRow=1;
    TilesPerColumn=1;
    DefinePatternSize();
    
    XORImageLeft=(width-XORImageW)/2;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Εικόνες
    drawIntroImage();
    drawLogoImage();
    //Κουμπιά
    if(introStep<6){
    	$("#divNewShape").hide();
    	drawButtonNext();
    }
    if(introStep>1){
    	drawButtonBack();
    }
	var promptYCoord=BottomPanelTop+25;
	if(introStep==5){
		   HscrTilesPerRow.render();
		   HscrTilesPerColumn.render();
		   HscrRedFactor.render();
		   HscrGreenFactor.render();
		   HscrBlueFactor.render();
		   chkRed.render();
		   chkGreen.render();
		   chkBlue.render();
		   cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Χρησιμοποίησε τις Μπάρες Κύλισης στα αριστερά για να αλλάξεις το πλήθος των ΕΠΑΝΑΛΗΨΕΩΝ");
		   cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Χρησιμοποίησε τις Μπάρες Κύλισης στο κέντρο για να ΕΠΙΛΕΞΕΙΣ το πλήθος των αποχρώσεων");
		   cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+40,"Χρησιμοποίησε τα Πλαίσια Ελέγχου στα δεξιά για να ΕΠΙΛΕΞΕΙΣ τα βασικά χρώματα");
		   xorGraphics1();
	}
	else if(introStep==6){
		$("#divNewShape").show();
		if(XORcounter==0){
			cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Εδώ μπορείς να πειραματιστείς με ένα παραλληλόγραμμο που αναπηδά στα όρια της επιφάνειας σχεδίασης.");
			cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Πάτα το κουμπί [Νέο Σχήμα] για να δεις διαφορετικό σχέδιο.");
		}
		else{
			if(XORcounter>=1){
				chkDrawMany.render();
			}
			if(XORcounter>=2){
				chkXORGraphics.render();
			}
			if(XORcounter>=3){
				chkFullColor.render();
			}
			if(XORcounter>=4){
				chkCompactDraw.render();
			}
			if(XORcounter==1){
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+40,"Το αποτέλεσμα θα γίνει πιο ενδιαφέρον αν ενεργοποιήσεις το Ίχνος σχεδίασης.");
			}
			if(XORcounter==2){
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Το σχήμα αρχίζει να γεμίζει με γραμμές και σύντομα θα είναι συμπαγές.");
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Για καλύτερο αποτέλεσμα μπορείς να ενεργοποιήσεις την Ανάμιξη Χρώματος.");
			}
			if(XORcounter==3){
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Το σχήμα είναι πραγματικά αρκετά περίτεχνο, αλλά κάτι του λείπει ακόμη...");
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Μάλλον παραείναι μονόχρωμο. Ας προσθέσουμε στον αλγόριθμο εντολές για χρωματική ποικιλία.");
			}
			if(XORcounter==4){
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Τώρα πλέον υπάρχει χρωματική ποικιλία, αλλά είναι πολύ... αχνή!");
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Ίσως το συμπαγές σχήμα να μην είναι τόσο κακή ιδέα τελικά.");
			}
			if(XORcounter==5){
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Βλέπεις λοιπόν πως 'χτίζεται' ένας αλγόριθμος ώστε σταδιακά να δίνει ολοένα και πιο σύνθετα αποτελέσματα.");
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Τώρα πλέον μπορείς να πειραματιστείς με τους συνδυασμούς όλων των παραμέτρων.");
				cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+40,"Αλλά να θυμάσαι ότι όλα αυτά γίνονται με ανάμειξη της Δομής Επιλογής και της Δομής Επανάληψης.");
			}
		}
	}
}

function drawIntroImage(){
	if(introStep!=6){
		Drawing=false;
	}
	Intro=document.getElementById("img"+introStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    if(fontName!=""){
    	cntx.font=fontSize+"px "+fontName;
    }
    if(clr!=""){
    	cntx.fillStyle=clr;
    }
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(introStep==5){
	    if(HscrTilesPerRow.markerHover(mx,my)){
	    	HscrTilesPerRow.markerGrabbed=true;
	    	HscrTilesPerRow.mouseXOffset=mx-HscrTilesPerRow.markerLeft;
	    }
	    else if(HscrTilesPerColumn.markerHover(mx,my)){
	    	HscrTilesPerColumn.markerGrabbed=true;
	    	HscrTilesPerColumn.mouseXOffset=mx-HscrTilesPerColumn.markerLeft;
	    }
	    else if(HscrRedFactor.markerHover(mx,my)){
	    	HscrRedFactor.markerGrabbed=true;
	    	HscrRedFactor.mouseXOffset=mx-HscrRedFactor.markerLeft;
	    }
	    else if(HscrGreenFactor.markerHover(mx,my)){
	    	HscrGreenFactor.markerGrabbed=true;
	    	HscrGreenFactor.mouseXOffset=mx-HscrGreenFactor.markerLeft;
	    }
	    else if(HscrBlueFactor.markerHover(mx,my)){
	    	HscrBlueFactor.markerGrabbed=true;
	    	HscrBlueFactor.mouseXOffset=mx-HscrBlueFactor.markerLeft;
	    }
	}
}

function handleMouseMove(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
    }
    
    canvas.style.cursor="default";
    if(introStep==5){
        if(HscrTilesPerRow.markerGrabbed){
        	HscrTilesPerRow.setMarkerPosition(mx-HscrTilesPerRow.mouseXOffset);
            TilesPerRow=HscrTilesPerRow.markerValue;
            canvas.style.cursor="pointer";
            DefinePatternSize();
        }
        else if(HscrTilesPerColumn.markerGrabbed){
        	HscrTilesPerColumn.setMarkerPosition(mx-HscrTilesPerColumn.mouseXOffset);
        	TilesPerColumn=HscrTilesPerColumn.markerValue;
            canvas.style.cursor="pointer";
            DefinePatternSize();
        }
        else if(HscrRedFactor.markerGrabbed){
        	HscrRedFactor.setMarkerPosition(mx-HscrRedFactor.mouseXOffset);
        	param1=Math.pow(2,HscrRedFactor.markerValue);
            canvas.style.cursor="pointer";
        }
        else if(HscrGreenFactor.markerGrabbed){
        	HscrGreenFactor.setMarkerPosition(mx-HscrGreenFactor.mouseXOffset);
        	param2=Math.pow(2,HscrGreenFactor.markerValue);;
            canvas.style.cursor="pointer";
        }
        else if(HscrBlueFactor.markerGrabbed){
        	HscrBlueFactor.setMarkerPosition(mx-HscrBlueFactor.mouseXOffset);
        	param3=Math.pow(2,HscrBlueFactor.markerValue);;
            canvas.style.cursor="pointer";
        }
        else if(HscrTilesPerRow.markerHover(mx,my) || HscrTilesPerColumn.markerHover(mx,my) || HscrRedFactor.markerHover(mx,my) || HscrGreenFactor.markerHover(mx,my) || HscrBlueFactor.markerHover(mx,my)){
            canvas.style.cursor="pointer";
        }
        if(chkRed.hover(mx,my) || chkGreen.hover(mx,my) || chkBlue.hover(mx,my)){
            canvas.style.cursor="pointer";
        }
    }

    if(!Drawing) drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if (mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<6) {
        introStep++;
        if(introStep==6){
    	    timerLoop=setInterval(function(){drawPattern();},simSpeed);
        }
    }
    if (mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1) {
        introStep--;
        clearInterval(timerLoop);
    }
    
    if(introStep==5){
    	HscrTilesPerRow.markerGrabbed=false;
    	HscrTilesPerColumn.markerGrabbed=false;
    	HscrRedFactor.markerGrabbed=false;
    	HscrGreenFactor.markerGrabbed=false;
    	HscrBlueFactor.markerGrabbed=false;
    	
    	if(chkRed.hover(mx,my)){
    		chkRed.toggleValue();
    	}
    	else if(chkGreen.hover(mx,my)){
    		chkGreen.toggleValue();
    	}
    	else if(chkBlue.hover(mx,my)){
    		chkBlue.toggleValue();
    	}
    }
    else if(introStep==6){
    	if(XORcounter>=1 && chkDrawMany.hover(mx,my)){
    		chkDrawMany.toggleValue();
    		itemStateChanged(chkDrawManyIndx);	
    	}
    	else if(XORcounter>=2 && chkXORGraphics.hover(mx,my)){
    		chkXORGraphics.toggleValue();
    		itemStateChanged(chkXORGraphicsIndx);	
    	}
    	else if(XORcounter>=3 && chkFullColor.hover(mx,my)){
    		chkFullColor.toggleValue();
    		itemStateChanged(chkFullColorIndx);	
    	}
    	else if(XORcounter>=4 && chkCompactDraw.hover(mx,my)){
    		chkCompactDraw.toggleValue();
    		itemStateChanged(chkCompactDrawIndx);	
    	}
    }
    drawBasicScreen();
}

function drawPixel(x,y,r,g,b,a,xorSwitch,ImageW){	
	var index=(x+y*ImageW)*4;
	if(xorSwitch){
		canvasData.data[index+0]=r ^ canvasData.data[index+0];
	    canvasData.data[index+1]=g ^ canvasData.data[index+1];
	    canvasData.data[index+2]=b ^ canvasData.data[index+2];
	    canvasData.data[index+3]=a;
	}
	else{
	    canvasData.data[index+0]=r;
	    canvasData.data[index+1]=g;
	    canvasData.data[index+2]=b;
	    canvasData.data[index+3]=a;
	}
}

function xorGraphics1(){
	//initialise canvas
	var imgLeft=(width-ImageW)/2;
	var imgTop=100;
	cntx.fillStyle="#000";
	cntx.fillRect(imgLeft,imgTop,ImageW,ImageH);
	//αποθήκευση των pixel στον καμβά
	canvasData=cntx.getImageData(imgLeft,imgTop,ImageW,ImageH);
	
	var r,g,b;
	var x=0,y=0;
	for(y=0;y<ImageH;y++) {
		for(x=0;x<ImageW;x++) {
			if(chkRed.value){
				   r=(x*param1^y*param1) & 0xff;
			}
			else {
				r=0;
			}
			if(chkGreen.value){
				g=(x*param2^y*param2) & 0xff;
			}
			else{
				g=0;
			}
			if(chkBlue.value){
				   b=(x*param3^y*param3) & 0xff;
			}
			else{
				b=0;
			}
			drawPixel(x,y,r,g,b,255,false,ImageW);
		}
	}
	updateCanvas(imgLeft,imgTop);
}

function updateCanvas(imgLeft,imgTop){
	if(introStep==5){
	    cntx.putImageData(canvasData,imgLeft,imgTop);
	}
	else if(introStep==6){
	    cntx.putImageData(canvasData,imgLeft,imgTop);
	}
}

function PrepareNewShape(){
	InitialiseRectangle();
	XORred=parseInt(Math.random()*255);
	XORgreen=parseInt(Math.random()*255);
	XORblue=parseInt(Math.random()*255);
	PrepareColorsSteps();
	ClearPicture();
}

function PrepareColorsSteps(){
	XOR_dRed=0;
	XOR_dGreen=0;
	XOR_dBlue=0;
	if(chkFullColor.value){
		if(Math.random()>=0.5) XOR_dRed=1;
		if(Math.random()>=0.5) XOR_dGreen=1;
		if(Math.random()>=0.5) XOR_dBlue=1;
	}
}

function DefinePatternSize(){
	ImageW=64*TilesPerRow;
	ImageH=64*TilesPerColumn;
}

function InitialiseRectangle(){
	RectangleX1=parseInt((XORImageW-2)*Math.random());
	RectangleY1=parseInt((XORImageH-2)*Math.random());
	InitialiseCoordSteps();
}

function InitialiseCoordSteps(){
	if(chkCompactDraw.value){
		dx=1;
		dy=1;
	}
	else{
		dx=parseInt(7*Math.random()+1);
		dy=parseInt(7*Math.random()+1);
	}
}

function ClearPicture(){
	var i,j;
	for(i=0;i<XORImageH;i++){
		for(j=0;j<XORImageW;j++){
			drawPixel(j,i,0,0,0,255,false,XORImageW);
		}
	}
}

function xorGraphics2(){
	clearCanvas();

	red=parseInt(200*Math.random());
	dRed=1;
	green=parseInt(200*Math.random());
	dGreen=1;
	blue=parseInt(200*Math.random());
	dBlue=1;
	Drawing=true;
}

function clearCanvas(){
	//initialise canvas
	cntx.fillStyle="#000000";
	cntx.beginPath();
	cntx.fillRect(XORImageLeft,XORImageTop,XORImageW,XORImageH);
	cntx.fill();
	//store pixels of canvas
	canvasData=cntx.getImageData(XORImageLeft,XORImageTop,XORImageW,XORImageH);
}

function drawPattern(){
	if(Drawing){
		if(!chkDrawMany.value){
			clearCanvas();
		}
		var xStart=Math.min(RectangleX1,XORImageW-RectangleX1);
		var xEnd=Math.max(RectangleX1,XORImageW-RectangleX1);
		var yStart=Math.min(RectangleY1,XORImageH-RectangleY1);
		var yEnd=Math.max(RectangleY1,XORImageH-RectangleY1);
		for(var i=xStart;i<=xEnd;i++){
			drawPixel(i,RectangleY1,red,green,blue,255,chkXORGraphics.value,XORImageW);
			drawPixel(i,XORImageH-RectangleY1,red,green,blue,255,chkXORGraphics.value,XORImageW);
		}
		for(var j=yStart;j<=yEnd;j++){
			drawPixel(RectangleX1,j,red,green,blue,255,chkXORGraphics.value,XORImageW);
			drawPixel(XORImageW-RectangleX1,j,red,green,blue,255,chkXORGraphics.value,XORImageW);
		}
		updateCanvas(XORImageLeft,XORImageTop);
		
		RectangleX1+=dx;
		if(RectangleX1<=0 || RectangleX1>=XORImageW){
			dx=-dx;
		}
		RectangleY1+=dy;
		if(RectangleY1<=0 || RectangleY1>=XORImageH){
			dy=-dy;
		}
		if(chkFullColor.value){
			red=red+dRed;
			if(red<=0 || red>=255){
				dRed = -dRed;
			}
			green+=dGreen;
			if(green<=0 || green>=255){
				dGreen=-dGreen;
			}
			blue+=dBlue;
		    if(blue<=0 || blue>=255){
		    	dBlue=-dBlue;
		    }
		}
	}
}

function itemStateChanged(slctr){
	if(slctr==chkDrawManyIndx){
		if(chkDrawMany.value && XORcounter==1) XORcounter=2;
	}
	else if(slctr==chkXORGraphicsIndx){
		if(chkXORGraphics.value && XORcounter==2) XORcounter=3;
	}
	else if(slctr==chkFullColorIndx){
		if(chkFullColor.value && XORcounter==3) XORcounter=4;
		PrepareColorsSteps();
	}
	else if(slctr==chkCompactDrawIndx){
		if(chkCompactDraw.value && XORcounter==4) XORcounter=5;
		InitialiseCoordSteps();
	}
	actionPerformed();
	if(!Drawing){
		drawBasicScreen();
	}
}

function actionPerformed(){
	if(XORcounter==0)XORcounter=1;
	PrepareNewShape();
	xorGraphics2();
	drawBasicScreen();
}
