/**
 * 
 */
var valuePosFixed=0;
var valuePosMovable=1;

function slider(x,y,w,h,min,max,markerVal,scaleVisible,scaleDigital,scaleLabels,viewComparative,cntx,mrkrOverhanging,markerValuePos){
	//ορισμός Κλίμακας
	this.left=x;
	this.top=y;
	this.width=w;
	this.height=h;
	this.heightToUse=this.height;
	this.min=min;
	this.max=max;
	this.mCntx=cntx;
	this.markerHover=false;
	this.markerGrabbed=false;
	this.scaleVisible=scaleVisible;
	this.scaleHeight=10;
	this.scaleDigital=scaleDigital;
	this.scaleFontSize=10;
	this.scaleBorder=10;
	this.scaleLabels=[];
	for(var i=0;i<scaleLabels.length;i++){
	    this.scaleLabels.push(scaleLabels[i]);	    
	}
	this.viewComparative=viewComparative;
	this.comparator="<=";
	this.comparativeColorTrue="lightGreen";
	this.comparativeColorFalse="red";
	
	//Ορισμοί Δείκτη
	this.markerOverhanging=mrkrOverhanging;
	var defaultMarkerWidth=10;
	var defaultMarkerHeight=this.markerOverhanging?24:this.height;
	this.markerValuePos=markerValuePos;

	var markLeft=x+w/2;
	var markTop=this.markerOverhanging?this.top-defaultMarkerHeight:this.top;
	var markWidth=defaultMarkerWidth;
	var markHeight=defaultMarkerHeight;
	var markerValue=markerVal;
	
	//Ορισμοί χρωμάτων
	this.mRed=0;
	this.mGreen=0;
	this.mBlue=0;
	this.fillColor="lightGrey";
	this.drawColor="black";
	this.scaleColor="black";

	this.renderScale=function(){
		var aCoef=(this.width-2*this.scaleBorder)/(this.max-this.min);
		var bCoef=this.left+this.scaleBorder-aCoef*this.min;
		if(this.viewComparative){
			var color1=this.comparativeColorTrue;
			var color2=this.comparativeColorFalse;
			if(this.comparator==">"){
				color1=this.comparativeColorFalse;
				color2=this.comparativeColorTrue;
			}
			this.mCntx.fillStyle=color1;
			this.mCntx.fillRect(this.left+this.scaleBorder,this.top+1,this.markerLeft+this.markerWidth/2-this.left-this.scaleBorder,this.heightToUse-2);
			this.mCntx.fillStyle=color2;
			this.mCntx.fillRect(this.markerLeft+this.markerWidth/2+1,this.top+1,this.width-(this.markerLeft+this.markerWidth/2-this.left)-this.scaleBorder,this.heightToUse-2);
		}
		this.mCntx.strokeStyle=this.scaleColor;
		this.mCntx.beginPath();
		for(var i=this.min;i<=this.max;i++){
			//Σχεδίαση υποδιαίρεσης
			var xScr=aCoef*i+bCoef;
			this.mCntx.moveTo(xScr,this.top);
			this.mCntx.lineTo(xScr,this.top+this.scaleHeight);
			//Εμφάνιση τιμής
			this.mCntx.font=this.scaleFontSize+"px Georgia";
			this.mCntx.fillStyle="black";
			var dx=this.mCntx.measureText(i).width/2;
			if(this.scaleLabels.length==0){
			    dx=this.mCntx.measureText(i).width/2;
			    this.mCntx.fillText(i,xScr-dx,this.top+this.scaleHeight+this.scaleFontSize);
			}
			else{
			    var labelToShow=" "+this.scaleLabels[i-this.min]+" ";
			    dx=this.mCntx.measureText(labelToShow).width/2;
			    this.mCntx.fillText(labelToShow,xScr-dx,this.top+this.scaleHeight+this.scaleFontSize);
			}
		}
		this.mCntx.stroke();
	};
	
	this.renderMarker=function(){
		//this.mCntx.fillStyle=this.fillColor;
		this.mCntx.fillStyle="Grey";

		this.mCntx.strokeStyle=this.drawColor;
		this.mCntx.beginPath();
		this.mCntx.moveTo(this.markerLeft,this.markerTop);
		this.mCntx.lineTo(this.markerLeft+this.markerWidth,this.markerTop);
		this.mCntx.lineTo(this.markerLeft+this.markerWidth,this.markerTop+2*this.markerHeight/3);
		this.mCntx.lineTo(this.markerLeft+this.markerWidth/2,this.markerTop+this.markerHeight);
		this.mCntx.lineTo(this.markerLeft,this.markerTop+2*this.markerHeight/3);
		this.mCntx.lineTo(this.markerLeft,this.markerTop);
		this.mCntx.fill();
		this.mCntx.stroke();
		
		//Σχεδίαση τιμής δείκτη
		this.mCntx.fillStyle="blue";
		if(this.markerValuePos==valuePosMovable){
			this.mCntx.font="14px Arial";
			var yOffset=this.top-(this.markerTop+this.markerHeight);
			if(this.markerOverhanging){
				yOffset=10;
			}
			if(this.scaleLabels.length==0){
		        this.mCntx.fillText(parseInt(this.markerValue*100)/100,this.markerLeft+this.markerWidth+5,this.top-yOffset);
			}
			else{
			    this.mCntx.fillText(" "+this.scaleLabels[this.markerValue-this.min],this.markerLeft+this.markerWidth+5,this.top-yOffset);
			}
		}
		else{
			this.mCntx.font="16px Georgia";
			this.mCntx.fillText(parseInt(this.markerValue*100)/100,this.left+this.width+5,this.top+this.height);
		}
		
		if(this.viewComparative){
			this.mCntx.strokeStyle="black";
			if(this.comparator.length>1){
				this.mCntx.fillStyle=this.comparativeColorTrue;
			}
			else{
				this.mCntx.fillStyle=this.comparativeColorFalse;
			}
			this.mCntx.beginPath();
			this.mCntx.arc(this.markerLeft+this.markerWidth/2,this.markerTop+this.markerHeight,3,0,2*Math.PI);
			this.mCntx.stroke();
			this.mCntx.fill();
		}
	};

	this.render=function(){
		this.heightToUse=this.height;
		this.heightToUse=this.scaleVisible?25:this.height;
		this.mCntx.fillStyle=this.fillColor;
		this.mCntx.strokeStyle=this.drawColor;
		this.mCntx.beginPath();
		this.mCntx.moveTo(this.left,this.top);
		this.mCntx.lineTo(this.left+this.width,this.top);
		this.mCntx.lineTo(this.left+this.width,this.top+this.heightToUse);
		this.mCntx.lineTo(this.left,this.top+this.heightToUse);
		this.mCntx.lineTo(this.left,this.top);
		this.mCntx.fill();
		this.mCntx.stroke();
		if(this.scaleVisible){
			this.renderScale();
		}
		//if(!this.viewComparative)this.renderMarker();
		this.renderMarker();
	};
	
	this.setMarkerValue=function(newValue){
		if(newValue<this.min){
			newValue=this.min;
		}
		else if(newValue>this.max){
			newValue=this.max;
		}
		else if(this.scaleDigital){
			newValue=parseInt(newValue+Math.sign(newValue)*0.5);
		}
		this.markerValue=newValue;
		var aCoef=(this.width-2*this.scaleBorder)/(this.max-this.min);
		var bCoef=this.scaleBorder+this.left-aCoef*this.min;
		this.markerLeft=aCoef*this.markerValue+bCoef-this.markerWidth/2;
		this.render();
	};

	this.defineMarker=function(mLeft,mTop,mWidth,mHeight,mVal){
		//αρχικοποίηση Δείκτη
		this.markerLeft=mLeft;
		this.markerTop=mTop;
		this.markerWidth=mWidth;
		this.markerHeight=mHeight;
		this.setMarkerValue(mVal);
		this.markerHover=false;
		this.markerGrabbed=false;
		this.mouseXOffset=0;
	};

	this.defineMarker(markLeft,markTop,markWidth,markHeight,markerValue);

	this.markerHover=function(mX,mY){
        var hover=mX>=this.markerLeft && mX<=this.markerLeft+this.markerWidth; 
        hover=hover && mY>=this.markerTop && mY<=this.markerTop+2*this.markerHeight/3;
        return hover;
	};
	
	this.setMarkerPosition=function(newPos){
		var newValue=(newPos-this.left+this.scaleBorder)*(this.max-this.min)/this.width+this.min;
		this.setMarkerValue(newValue);
	};
}